package de.hdm_stuttgart.mi.sd1.task1;

import de.hdm_stuttgart.mi.sd1.task2.Unit;

/**
 * <p>This enum provides Body Mass Index (BMI) related methods.</p>
 *
 * <p>A person's Body Mass Index b corresponding to weight w and height h is being defined
 *    by \( b =  w / {h^2}\). We assume metric units kilogram (kg) and meter (m). The BMI's unit will thus be
 *    \( kg \over m^2\). The following diagram shows selected BMI graphs for both metric and imperial units:</p>
 *
 * <img src="doc-files/bmi.png" style="width: 70rem;" alt='6 Body mass categories'/>
 *
 * <p>The six different colors correspond to the six enum categories {@link _3_BmiCategory#UNDERWEIGHT},
 * {@link _3_BmiCategory#NORMALWEIGHT}, ..., {@link _3_BmiCategory#VERY_SEVERELY_OBESE}. </p>
 *
 * <section class="implementationHints">
 *    <h2>Hint:</h2>
 *
 *    <p>The auto-generated {@link #values()} and {@link #valueOf(String)} methods appearing in Javadoc may
 *    be helpful but do not have to be implemented by you.</p>
 *
 * </section>
 */
public enum _3_BmiCategory {

    /**
     * BMI range \( [0, 18.5[\)
     */
    UNDERWEIGHT,
    /**
     * BMI range \( [18.5, 25[\)
     */
    NORMALWEIGHT,
    /**
     * BMI range \( [25, 30[\)
     */
    OVERWEIGHT,
    /**
     * BMI range \( [30, 35[\)
     */
    MODERATELY_OBESE,
    /**
     * BMI range \( [35, 40[\)
     */
    SEVERELY_OBESE,
    /**
     * BMI range \( [40, \infty[\)
     */
    VERY_SEVERELY_OBESE;

    /**
     * <p>Get a given BMI category's successor.</p>
     * <p>Example: {@link #OVERWEIGHT} is the successor category of {@link #NORMALWEIGHT}. </p>
     *
     * @return A category's successor or <code>null</code> if starting from {@link #VERY_SEVERELY_OBESE}.
     */
    public _3_BmiCategory getFollowingCategory() {
        return null; // TODO: implement me correctly
    }

    /**
     * <p>Calculate a person's BMI category:</p>
     *
     * <p>Example: A person of 95kg and 1.80 m in height does have a BMI of
     *   \({95 / 1.8^2} \approx 29.32 \) belonging to the [25, 30[ range and thus to the
     *   <code>OVERWEIGHT</code> category.</p>
     *
     * @param weight A person's weight in kilograms
     * @param height A person's height in meters.
     * @return One of {@link #UNDERWEIGHT}, {@link #NORMALWEIGHT}, ..., {@link #VERY_SEVERELY_OBESE} categorizing
     * the person's BMI in question.
     *
     * <section class="implementationHints">
     *    <h4>Hint:</h4>
     *
     *    <ul>
     *        <li>There are different ways handling range limits. You may extend the current enum class to suit your
     *        needs. The individual enum definitions might be a good place for storing range limits like 18.5, 25
     *        and so on.</li>
     *    </ul>
     *
     * </section>
     */
    static public _3_BmiCategory getCategory(final double weight, final double height) {
        return null; // TODO: implement me correctly
    }
}
