package de.hdm_stuttgart.mi.sd1.test.task2;

import de.hdm_stuttgart.mi.exam.unitmarking.ExaminationTestDefaults;
import de.hdm_stuttgart.mi.exam.unitmarking.Marking;
import de.hdm_stuttgart.mi.sd1.task2.LengthUnitCalculator;
import de.hdm_stuttgart.mi.sd1.task2.Unit;
import de.hdm_stuttgart.mi.sd1.test.ignore_me.ObjectWrapper;
import org.junit.Assert;
import org.junit.FixMethodOrder;
import org.junit.Test;
import org.junit.runners.MethodSorters;

@FixMethodOrder(MethodSorters.NAME_ASCENDING)
public class Test_LengthUnitCalculator extends ExaminationTestDefaults {

    static private final double testPrecision = 1.E-7;

    static private final double
            INCH_IN_METER = 0.0254,
            MILE_IMPERIAL_IN_METER = 1609.344,
            MILE_NAUTICAL_IN_METER = 1852.0;

    @Test @Marking(points = 10)
    public void test_300() {
        final ObjectWrapper<LengthUnitCalculator> c =
                new ObjectWrapper<>(LengthUnitCalculator.class, Unit.MILE_NAUTICAL);

        c.invoke(void.class,"setLength", 2.0);
        c.invoke(void.class,"setUnit", Unit.METER);

        Assert.assertEquals(2 * MILE_NAUTICAL_IN_METER, c.invoke(double.class, "getLength"), testPrecision);

        c.invoke(void.class,"setUnit", Unit.INCH);
        c.invoke(void.class,"setLength", 8.0);
        c.invoke(void.class,"setUnit", Unit.METER);

        Assert.assertEquals(8 * INCH_IN_METER, c.invoke(double.class, "getLength"), testPrecision);
    }

    @Test @Marking(points = 10)
    public void test_320() {
        final ObjectWrapper<LengthUnitCalculator> c =
                new ObjectWrapper<>(LengthUnitCalculator.class);

        c.invoke(void.class,"setLength", 15.0);
        Assert.assertEquals(15, c.invoke(double.class, "getLength"), testPrecision);

        c.invoke(void.class,"setUnit", Unit.INCH);
        Assert.assertEquals(15 / INCH_IN_METER, c.invoke(double.class, "getLength"), testPrecision);

        // Setting 5 imperial miles
        c.invoke(void.class,"setUnit", Unit.MILE_IMPERIAL);
        c.invoke(void.class,"setLength", 5.0);

        // Switching to nautical mile units
        c.invoke(void.class,"setUnit", Unit.MILE_NAUTICAL);
        Assert.assertEquals(5 * MILE_IMPERIAL_IN_METER  / MILE_NAUTICAL_IN_METER,
                c.invoke(double.class, "getLength"), testPrecision);
    }

}
